#include "gmp.h"

int
main(int argc, char *argv[])
{ 
  unsigned long p, pmin, pmax, i;
  mpz_t ll, aux, lll, llu;

  mpz_init(ll);
  mpz_init(lll);
  mpz_init(llu);
  mpz_init(aux);

  pmin = pmax = atol(argv[1]);
  if ( argc >= 3 ) pmax = atol(argv[2]);

  for ( p = pmin ; p <= pmax ; p++ )
  {

  mpz_set_ui(aux,p);
  if ( mpz_probab_prime_p(aux,40) == 0 ) continue;

  mpz_set_ui(ll,(long)(4));
  mpz_ui_pow_ui(aux,(long)(2),p);
  
  for ( i = 1 ; i + 2 <= p ; i++ )
  {
    mpz_mul(aux,ll,ll); 
           /* Elevamos ll ao quadrado ... */
    mpz_fdiv_q_2exp(llu,aux,p);
    mpz_fdiv_r_2exp(lll,aux,p);
    mpz_add(aux,llu,lll);
    mpz_fdiv_q_2exp(llu,aux,p);
    mpz_fdiv_r_2exp(lll,aux,p);
    mpz_add(aux,llu,lll);
           /* ... reduzimos o quadrado modulo Mp ... */
    mpz_sub_ui(ll,aux,(long)(2)); 
           /* ... e subtraimos 2, para calcular s(p-2) modulo Mp. */
  }

  if ( mpz_sgn(ll) == 0 )
  { printf("M%ld  primo.\n",p); }
  else
  { printf("M%ld  composto.\n",p); } /* Imprimimos as concluses. */

  }

  return(0);
}
