#include <stdlib.h>
#include <stdio.h>
#include <gmp.h>

mpz_t pp; 

int
proth(unsigned long h, unsigned long k)
{
  unsigned long i;
  mpz_t pm, test, aux;
  extern mpz_t pp;  
  
  mpz_init(pm);
  mpz_init(test);
  mpz_init(aux);    

  mpz_ui_pow_ui(pm,(long)(2),k);
  mpz_mul_ui(pm,pm,h);
  mpz_fdiv_q_2exp(aux,pm,(long)(1)); 
  mpz_add_ui(pp,pm,(long)(1)); 
  /* Calculamos pp = hh * 2^k + 1, pm = pp - 1 e aux = (pp-1)/2. */

  mpz_set_ui(test,(long)(2));
  mpz_powm(test,test,aux,pp); 
  if ( mpz_cmp(test,pm) == 0 )
  {
    mpz_clear(pm);
    mpz_clear(test);
    mpz_clear(aux);    
    return(1);
  }
  if ( mpz_cmp_ui(test,(long)(1)) != 0 )
  {
    mpz_clear(pm);
    mpz_clear(test);
    mpz_clear(aux);    
    return(0);
  }

  for ( i = 3 ; i < 1000 ; i += 2 )
  {
    mpz_set_ui(test,i);
    if ( mpz_probab_prime_p(test,25) )
    {
      mpz_powm(test,test,aux,pp); 
      if ( mpz_cmp(test,pm) == 0 )
      {
        mpz_clear(pm);
        mpz_clear(test);
        mpz_clear(aux);    
        return(1);
      }
      if ( mpz_cmp_ui(test,(long)(1)) != 0 )
      {
        mpz_clear(pm);
        mpz_clear(test);
        mpz_clear(aux);    
        return(0);
      }
    }
  }

  mpz_clear(pm);
  mpz_clear(test);
  mpz_clear(aux);    
  return(-1);
}

int
main(int argc, char *argv[])
{ 
  int answ;
  unsigned long h, hmin, hmax, k;
  extern mpz_t pp;

  hmin = atol(argv[1]);
  hmax = atol(argv[2]);
  k = atol(argv[3]);
  mpz_init(pp);

  for ( h = hmin ; h <= hmax ; h++ ) if ( h & 1 )
  {
    answ = proth(h,k);
    if ( answ == 1 )
    {
      printf("%ld * 2^%ld + 1 = ",h,k);
      mpz_out_str(stdout,10,pp);
      printf("  primo.\n");
    }
    else if ( answ < 0 ) printf("%ld * 2^%ld + 1: difcil...\n",h,k);
  }

  return(0);
}
